#!/usr/bin/env python

from time import sleep
from collections import deque
import numpy as np
import scipy.signal

from zoetrope import aniplot as plt
from bstrd import BS, bsstream
plt.blit = False

def unpumpedXrays(events, *arrays):
    laser = events[:, 18]
    darkShot = events[:, 21]
    background_shots = np.logical_and.reduce((laser, darkShot))
    return [a[background_shots] for a in arrays]

def pumpedXrays(events, *arrays):
    fel = events[:, 13]
    laser = events[:, 18]
    darkShot = events[:, 21]
    pumped_shots = np.logical_and.reduce((laser, np.logical_not(darkShot)))
    return [a[pumped_shots] for a in arrays]


# config
diode_PV = "SLAAR11-LSCP1-FNS:CH4:VAL_GET"
events_PV = "SAR-CVME-TIFALL4:EvtSet"
length = 1000

# create channel
diode = BS(diode_PV)
events = BS(events_PV)
sigs = np.empty(10)
events = np.empty((10,256))

# create a buffer for the plotting

pp_sig = deque(maxlen=length)

# create the empty plot
pd = plt.plot([0])

# some plot settings
plt.suptitle(diode_PV)
#plt.fig.set_figheight(12)
#plt.fig.set_figwidth(9)
plt.tight_layout()

for counter, data in zip(plt.show(), bsstream):
    print(counter)

    for i in range(10):
        diode_sig = diode.get()
        evt_codes = events.get()
        sigs.append(pp_sig)
        evts.append(evt_codes)
        i += 1

    sig_p = np.mean(pumpedXrays(events, signals))
    sig_un = np.mean(unpumpedXrays(events, signals))

    pp_sig.append(-np.log10(sig_p/sig_un))

    xs = np.arange(len(pp_sig))
    pd.set(xs, pp_sig)

    # this, I need to move into the library
    pd.ax.relim()
    pd.ax.autoscale_view()

bsstream.close()
